<div class="candidate-management">
  <h2 class="pb-2 header">
    <span id="category-management-page-heading" jhiTranslate="candidateManagement.home.title">Candidate
      management</span>

    <button class="btn btn-primary float-right jh-create-entity" *ngIf="mode === 'ACTION'"
      (click)="openCreateList()">Create list</button>

    <div ngbDropdown class="d-inline-block float-right jh-create-entity" *ngIf="mode === 'VIEW'">
      <button type="button" class="btn btn-primary" id="dropdownBasic1" ngbDropdownToggle>Export</button>
      <div ngbDropdownMenu aria-labelledby="dropdownBasic1">
        <button ngbDropdownItem (click)="openExportPdf()">Export PDF</button>
        <button ngbDropdownItem (click)="onExportExcel()">Export CVs</button>
      </div>
    </div>
  </h2>
  <jhi-candidate-filter (filterEvent)="onFilter($event)" (changeListEvent)="onChangeList($event)">
  </jhi-candidate-filter>

  <div class="row text-center mt-5">
    <div class="col-12">
      <div class="alert alert-secondary" role="alert" *ngIf="candidates && candidates.length === 0">
        <span jhiTranslate="global.dataEmpty"> candidates are empty! </span>
      </div>
    </div>
  </div>
  <div class="candidate-management__control" *ngIf="candidates && candidates.length">
    <div class="candidate-management__control__filter">
      <div *ngIf="selectedCandidateIds.length">
        <button *ngIf="!filtered && filterListId !== 0" (click)="setCandidateToList()">
          Set to list
        </button>
        <button *ngIf="filtered && filterListId !== 0" (click)="removeCandidateFromList()">
          Remove form list
        </button>
        <p *ngIf="filterListId !== 0">
          Select {{selectedCandidateIds.length}} records
        </p>
      </div>
    </div>
    <div class="candidate-management__control__mode">
      <div ngbDropdown class="d-inline-block" #columnConfigDrop="ngbDropdown" placement="bottom-right">
        <button type="button" class="btn btn-outline-info" id="dropdownForm1" ngbDropdownToggle>Columns</button>
        <div ngbDropdownMenu aria-labelledby="dropdownForm1" class="column-list-control">
          <h4>Columns</h4>
          <input type="text" class="form-control search" [(ngModel)]="searchColumnKey"
            (ngModelChange)="onSearchColumn($event)" placeholder="{{'candidateManagement.filter.search' | translate}}">
          <form>
            <p class="text-primary hand" (click)="setToDefaultConfigColumn()">Restore Defaults</p>
            <div class="form-check" *ngFor="let column of columnsConfigDisplay">
              <input type="checkbox" class="form-check-input hand" [id]="'dropdownCheck' + column.key"
                [value]="column.key" (change)="onSelectColumnConfig($event)" [checked]="column.show">
              <label class="form-check-label font-weight-normal hand" [for]="'dropdownCheck' + column.key"
                [jhiTranslate]="'candidateManagement.table.' + column.key">
                {{column.label}}
              </label>
            </div>
          </form>
          <div class="dropdown-divider"></div>
          <div class="dropdown-footer">
            <button type="button" class="btn" (click)=" cancelColumnsConfig(); columnConfigDrop.close();"
              NgbDropdownToggle>Cancel</button>
            <button type="button" class="btn btn-primary"
              (click)="saveColumnsConfig(); columnConfigDrop.close();">Done</button>
          </div>
        </div>
      </div>
      <div class="candidate-management__control__mode__view">
        <button [ngClass]="{ 'active' : mode === 'VIEW'}" (click)="changeModeToView()">
          <i class="bi bi-eye"></i>
        </button>
        <button [ngClass]="{ 'active' : mode === 'ACTION'}" (click)="changeModeToEdit()">
          <i class="bi bi-pencil-square"></i>
        </button>
      </div>
    </div>
  </div>
  <div class="table-responsive border-table table-fixed mt-3" *ngIf="candidates && candidates.length">
    <table class="table table-striped mb-0 table-fixed" aria-describedby="region-management-page-heading">
      <thead class="thead-light">
        <tr jhiSort [(predicate)]="predicate" [(ascending)]="ascending" [callback]="transition.bind(this)">
          <th scope="col" *ngIf="mode === 'ACTION'" class="fixed-side fixed-header"></th>
          <ng-container *ngFor="let column of columns">
            <th [jhiSortBy]="column.key" *ngIf="column.show" class="fixed-header"
              [ngClass]="{'fixed-side': column.fixed}"><span
                [jhiTranslate]="'candidateManagement.table.' + column.key">{{column.label}}</span>
              <fa-icon icon="sort" *ngIf="column.sort"></fa-icon>
            </th>
          </ng-container>
        </tr>
      </thead>
      <tbody>
        <tr *ngFor="let candidate of candidates;">
          <td class="fixed-side" *ngIf="mode === 'ACTION'">
            <div class="candidate-management__table__edit-group-button">
              <input type="checkbox" class="hand" [checked]="isSelectedItem(candidate.id)" [value]="candidate.id"
                (change)="onSelectCandidate($event)">
              <button (click)="gotoEdit(candidate.id)" ngbTooltip="{{'entity.action.edit' | translate}}" type="button">
                <i class="bi bi-pencil"></i>
              </button>
              <button ngbTooltip="{{'entity.action.delete' | translate}}" type="button" (click)="openDeleteCandidate(candidate.id, candidate.firstName)" >
                <i class="bi bi-trash"></i>
              </button>
            </div>
          </td>
          <ng-container *ngFor="let column of columns">
            <td *ngIf="column.show" [ngClass]="{'fixed-side': column.fixed}">
              <container-element [ngSwitch]="column.key">
                <div *ngSwitchCase="'cvDTO'">
                  <a *ngIf="candidate[column.key]" [href]="candidate[column.key].url" target="_blank"
                    ngbTooltip="{{'entity.action.view' | translate}}" class="hover-blue important">
                    {{candidate[column.key].fileName}}
                  </a>
                  <button *ngIf="candidate[column.key]" class="btn p-0" (click)="viewCvList(candidate.id, candidate.firstName)">
                    <i class="bi bi-card-list"></i>
                  </button>
                </div>
                <a *ngSwitchCase="'firstName'" [routerLink]="['./detail/' + candidate.id]" class="text-primary">
                  {{renderValueCandidate(candidate[column.key])}}
                </a>
                <span *ngSwitchCase="'createdDate'">
                  {{renderValueCandidate(candidate[column.key]) | date: 'dd/MM/yyyy'}}
                </span>
                <span *ngSwitchCase="'lastModifiedDate'">
                  {{renderValueCandidate(candidate[column.key]) | date: 'dd/MM/yyyy'}}
                </span>
                <span *ngSwitchDefault>{{renderValueCandidate(candidate[column.key])}}</span>
              </container-element>

            </td>
          </ng-container>
        </tr>
      </tbody>
    </table>

  </div>

  <div *ngIf="candidates" class="pt-5 d-flex justify-content-end mr-0">
    <jhi-item-count class="mr-4 align-self-center" [page]="page" [total]="totalItems" [itemsPerPage]="itemsPerPage">
    </jhi-item-count>
    <ngb-pagination size="sm" [collectionSize]="totalItems" [(page)]="page" [pageSize]="itemsPerPage" [maxSize]="3"
      [rotate]="true" [boundaryLinks]="true" (pageChange)="transition()"></ngb-pagination>
  </div>
</div>